import java.util.Scanner;

public class Kalender {
	
	/**
	* main-Methode: liest von der Standardeingabe ein und arbeitet die
	* eingegebenen Befehle ab. 
	*/
	public static void main(String[] args) {
		
		Scanner scanIn = new Scanner(System.in);
		Scanner scanLine;
		
		// FILL IN: Deklaration des Kalenders
		// solution::
		String[] cal = new String[31];
		// ::solution
		      
		// FILL IN: Initialisierung des Kalenders
		// solution::
		for (int i = 0; i < 31; ++i)
			cal[i] = "/";
		// ::solution

		while (scanIn.hasNextLine()) {
			scanLine = new Scanner(scanIn.nextLine());

			String command = scanLine.next();

			if (command.equals("k")) {
				// FILL IN: Anzeige des Kalenders unter Verwendung der Methode anzeigen
				// solution::
				anzeigen(scanLine.nextInt(), cal);
				// ::solution
			}
			// FILL IN: Verarbeitung der restlichen Befehle, unter Verwendung 
			// der entsprechenden Methoden (s.u.)
			// 
			// jeder Aufruf von scanLine.next() liefert einen Parameter des 
			// Befehls (als String) zurueck,
			// bzw. scanLine.nextInt(), falls es ein ganzzahliger Parameter ist
			// solution::
			else if (command.equals("e")) {
				eintragen(cal, scanLine.nextInt(), scanLine.next().charAt(0), scanLine.next());
			} else if (command.equals("w")) {
				eintragenWoechentlich(cal, scanLine.nextInt(), scanLine.next().charAt(0), scanLine.next());
			} else if (command.equals("z")) {
				System.out.println(anzahl(cal, scanLine.next().charAt(0)));
			} else if (command.equals("a")) {
				aendern(cal, scanLine.next(), scanLine.next().charAt(0));
			} else if (command.equals("v")) {
				verschieben(cal, scanLine.nextInt(), scanLine.nextInt(), scanLine.nextInt());
			}
			// ::solution

		}
		
	}

	/**
	* Erzeugt eine Stringdarstellung eines Tageseintrags.
	* Sie brauchen diese Methode nicht zu ändern.
	* 
	* @param tag  Nummer das Tages (zwischen 1 und 31)
	* @param eintrag Eintrag für diesen Tag
	* @return die Stringdarstellung
	*/
	public static String tagToString(int tag, String eintrag) {
		return tag+": " + eintrag.charAt(0) + " " + eintrag.substring(1);
	}

	/**
	* Gibt den Kalender ab einem bestimmten Tag (inklusive) zeilenweise aus.
	* Davor wird in einer Zeile "Aufgaben:" ausgegeben.
	* Verwenden Sie die obige Methode tagToString!
	*
	* @param tag Nummer das Tages (zwischen 1 und 31), ab dem ausgegeben werden soll (inklusive)
	* @param kalender der Kalender, der ausgegeben werden soll
	*/
	public static void anzeigen(int tag, String[] kalender) {
		// FILL IN
		// solution::
		System.out.println("Aufgaben:");
		while(tag <= 31) {
			System.out.println(tagToString(tag, kalender[tag-1]));
			tag = tag + 1;
		}
		// ::solution
	}

	/**
	* Tragt eine Aufgabe mit ihrer Priorität an einen bestimmten Tag
	* in einen Kalender ein, wenn der bisherige Eintrag an diesem
	* Tag leer ist oder eine niedrigere Priorität besitzt.
	* 
	* @param kalender der Kalender, in den eingetragen werden soll
	* @param tag der Tag des Monats, an dem die Aufgabe eingetragen werden soll
	* @param prio die Priorität der einzutragenden Aufgabe
	* @param aufgabe die einzutragende Aufgabe
	*/
	public static void eintragen(String[] kalender, int tag, char prio, String aufgabe) {
		// FILL IN
		// solution::
		if (kalender[tag-1].charAt(0) == '/' || kalender[tag-1].charAt(0) > prio)
			kalender[tag-1] = prio + aufgabe;
		// ::solution
	}


	/**
	* Wöchentliches Eintragen einer Aufgabe mit ihrer Priorität in einen Kalender.
	* Jeder Eintrag geschieht nur, wenn der bisherige Eintrag an diesem Tag leer
	* ist oder eine niedrigere Priorität besitzt.
	* <i>Achtung: Nutzen Sie für die Implementierung dieser Methode die Methode eintragen!</i>
	* 
	* @param kalender der Kalender, in den eingetragen werden soll
	* @param tag der Tag des Monats, an dem die Aufgabe eingetragen werden soll
	* @param prio die Priorität der einzutragenden Aufgabe
	* @param aufgabe die einzutragende Aufgabe
	*/
	public static void eintragenWoechentlich(String[] kalender, int tag, char prio, String aufgabe) {
		// FILL IN
		// solution::
		while (tag <= 31) {
			eintragen(kalender, tag, prio, aufgabe);
			tag += 7;
		}
		// ::solution
	}


	/**
	* Berechnet die Anzahl der Kalendereinträge mit einer bestimmten Priorität.
	* 
	* @param kalender der Kalender, dessen Einträge gezählt werden sollen
	* @param prio die Priorität, die die zu zählenden Einträge haben
	* @return Die Anzahl der Einträge mit der gegebenen Priorität
	*/
	public static int anzahl(String[] kalender, char prio) {
		// FILL IN
		/* impl::
		return 0; // diese Zeile entfernen
		*/
		// solution::
		int n = 0;
		for (int i = 0; i < 31; ++i)
			if (kalender[i].charAt(0) == prio)
				++n;
		return n;
		// ::solution
	}

	/**
	* Ändert die Priorität für jeden Eintrag einer Aufgabe in einem Kalender.
	* 
	* @param kalender der zu ändernde Kalender
	* @param aufgabe die Aufgabe, deren Vorkommnisse geändert werden sollen
	* @param prio die neue Priorität, die die zu ändernden Aufgaben bekommen sollen
	*/
	public static void aendern(String[] kalender, String aufgabe, char prio) {
		// FILL IN
		// solution::
		for (int i = 0; i<31; ++i)
			if (kalender[i].substring(1).equals(aufgabe))
				kalender[i] = prio + aufgabe;
		// ::solution
	}
				
	/**
	* Verschieben einer Reihe von Einträge eines Kalenders.
	* <i>Beachten Sie die genaue Definition in der Angabe!</i>
	* 
	* @param kalender der zu ändernde Kalender
	* @param von der Tag, ab dem Einträge verschoben werden sollen (inklusive)
	* @param bis der Tag, bis dem Einträge verschoben werden sollen (inklusive)
	* @param um die Anzahl an Tagen, um die die Einträge verschoben werden sollen (&ge;0)
	*/
	public static void verschieben(String[] kalender, int von, int bis, int um) {
		// FILL IN
		// - Wichtig! Beginnen Sie von *hinten* mit dem Tag "bis" und gehen 
		//            Sie schrittweise nach vorne, bis zum Tag "von"
		// - "Prioritaet p1 ist höher als p2" entspricht (int)p1 < (int)p1
		// solution::
		for (int ziel = bis + um; ziel>= von + um; --ziel) {
			if (ziel > 31) continue;
			if (kalender[ziel-um-1].charAt(0) == '/') continue;
			if (kalender[ziel-1].charAt(0) == '/' || kalender[ziel-1].charAt(0) > kalender[ziel-um-1].charAt(0)) {
				kalender[ziel-1] = kalender[ziel-um-1];
				kalender[ziel-um-1] = "/";
			}
		}
		// ::solution
	}

}

